#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>
#include<lt.h>
/****************************************************************/
/*      nom:        o_pixsource              */
/*      auteur:     Johan Richard         */
/*      date:       02/01/14            */
/*      place:      Lyon                */
/****************************************************************/

void precompsource(){
    FILE *fp;
    struct point Pi, Ps;
   const extern  struct  pot lens[];
    const extern struct g_source  S;
   extern struct g_mode M; // M.iclean
   const extern struct g_observ  O;
   extern struct g_pixel imFrame,ps,PSF;
   extern double **fluxmap;
    double **tmpimage ;
   int ni=imFrame.nx*imFrame.ny;
   int ns=ps.nx*ps.ny;
    double stepx,stepxs,stepy,stepys;
    double  ra, dec, width, height;
   fluxmap=(double **)alloc_square_double(ni,ns);
   double dlsds = dratio(lens[0].z, M.zclean);
   double sizeratio=imFrame.pixelx/ps.pixelx; // pixel size ratio between image and source plane
  double xs,ys;
    
    wcsfull(ps.wcsinfo, &ra, &dec, &width, &height);
    ps.xmin -= 3600.*cos(M.ref_dec * DTR) * (ra - M.ref_ra);
    ps.xmax -= 3600.*cos(M.ref_dec * DTR) * (ra - M.ref_ra);
    ps.ymin -= -3600.*(dec - M.ref_dec);
    ps.ymax -= -3600.*(dec - M.ref_dec);
 /*   fprintf(stderr,"ps.nx=%d\t ps.ny=%d\n",ps.nx,ps.ny);
    fprintf(stderr,"imFrame.pixelx=%lf\t imFrame.pixely=%lf\n",imFrame.pixelx,imFrame.pixely);
    fprintf(stderr,"ps.pixelx=%lf\t ps.pixely=%lf\n",ps.pixelx,ps.pixely);
    fprintf(stderr,"imFrame.xmax=%lf\t imFrame.ymax=%lf\n",imFrame.xmax,imFrame.ymax);
    fprintf(stderr,"imFrame.xmin=%lf\t imFrame.ymin=%lf\n",imFrame.xmin,imFrame.ymin);
    fprintf(stderr,"ps.xmax=%lf\t ps.ymax=%lf\n",ps.xmax,ps.ymax);
    fprintf(stderr,"ps.xmin=%lf\t ps.ymin=%lf\n",ps.xmin,ps.ymin); */
    fprintf(stderr, "sizeratio= %lf\n", sizeratio);
   tmpimage=(double **)alloc_square_double(imFrame.ny,imFrame.nx);
   int is,js,i,j;
    double z;
    stepx=(imFrame.xmax-imFrame.xmin)/(imFrame.nx-1);
    stepy=(imFrame.ymax-imFrame.ymin)/(imFrame.ny-1);
    stepxs=(ps.xmax-ps.xmin)/(ps.nx-1);
    stepys=(ps.ymax-ps.ymin)/(ps.ny-1);
    fprintf(stderr,"stepxs=%.8lf\t stepys=%.8lf\n",stepxs,stepys);
    fprintf(stderr,"stepx=%.8lf\t stepy=%.8lf\n",stepx,stepy);
    for (i=0;i<imFrame.nx;i++)
    for(j=0;j<imFrame.ny;j++)
        tmpimage[j][i]=0.0;
    for (i=0;i<ni;i++)
        for(j=0;j<ns;j++)
            fluxmap[i][j]=0.0;
    xs= ps.xmin;
  //  ys=ps.ymin;
    fp = fopen("fluxmap.dat","w");
     for(is=0;is<ps.nx;is++)
   { fprintf(stderr, "is=%d\n",is);
      // xs = is * (ps.xmax - ps.xmin) / (ps.nx - 1) + ps.xmin;
       ys=ps.ymin;
      for(js=0;js<ps.ny;js++)
      {//fprintf(stderr, "js=%d\t ys=%lf\n",js,ys);
     //   ys = js * (ps.ymax - ps.ymin) / (ps.ny - 1) + ps.ymin;
         
          Pi.x= imFrame.xmin;
          
        for(i=0;i<imFrame.nx;i++)
        {
            Pi.y=imFrame.ymin;
         //   Pi.x = i * (imFrame.xmax - imFrame.xmin) / (imFrame.nx - 1) + imFrame.xmin;
          for(j=0;j<imFrame.ny;j++)
          {
           //   fprintf(fp, "is=%d\t xs=%lf\t js=%d\t ys=%lf\t i=%d\t Pi.x=%lf\t j=%d\t Pi.y=%lf\n",is,xs,js,ys,i,Pi.x,j,Pi.y);
           // Pi.y = j * (imFrame.ymax - imFrame.ymin) / (imFrame.ny - 1) + imFrame.ymin;
           
            e_dpl(&Pi, dlsds,S.zs, &Ps);
              z= (Ps.x-xs)*(Ps.x-xs)/stepxs/stepxs+(Ps.y-ys)*(Ps.y-ys)/stepys/stepys;
         // fprintf(fp, "Pi.x=%lf\t Pi.y=%lf\t Ps.x=%lf \t Ps.y=%lf \t xs=%lf \t ys=%lf\n",Pi.x,Pi.y,Ps.x,Ps.y,xs,ys);
              if(z<0.25)
              {  
               tmpimage[j][i]=sizeratio;
          //  fprintf(stderr, "sizeratio\n");
              }
            else
            tmpimage[j][i]=0.0;
              Pi.y +=stepy;
          }
            Pi.x +=stepx;
        }
        
      /*  convolve tmpimage with PSF */
        if (O.setseeing)
               d_seeing_omp(tmpimage, imFrame.nx, imFrame.ny, imFrame.pixelx);

       /* store tmpimage in flux matrix */
        for(i=0;i<imFrame.nx;i++)
        {
          for(j=0;j<imFrame.ny;j++)
          {
           fluxmap[i*imFrame.ny+j][is*ps.ny+js]=tmpimage[j][i];
       if(fluxmap[i*imFrame.ny+j][is*ps.ny+js]>1.e-15)
           fprintf(fp,"fluxmap[%d][%d]=%e\t tmpimage[%d][%d]=%e\n",(i*imFrame.ny+j),(is*ps.ny+js),fluxmap[i*imFrame.ny+j][is*ps.ny+js],j,i,tmpimage[j][i]);
          }
        }
        ys+=stepys;
     }
       xs+=stepxs;
   }
      fclose(fp);
   
   free_square_double(tmpimage,imFrame.ny);
   
}

void testpixel(double **zz,double *sflux)
{
    const extern struct g_observ  O;
    extern struct g_mode    M;
    extern struct g_pixel   ps,imFrame;
    extern double **fluxmap;
    double xmin, ymin, xmax, ymax, dx, dy;
    double f, scale;
    int nx, ny;
    FILE *fp;
    int i,j,k;
double  ra, dec, width, height;
    xmin = imFrame.xmin;
    xmax = imFrame.xmax;
    ymin = imFrame.ymin;
    ymax = imFrame.ymax;

    dx = xmax - xmin;
    dy = ymax - ymin;
    nx = imFrame.nx;// default: assign np to nx and adjust ny
   // ny = imFrame.ny;
    scale = dx / (nx-1);
    ny = dy / scale + 1;  // warning: trunc(ny) behavior

    dx = (nx - 1) * scale;
    dy = (ny - 1) * scale;
    xmax = xmin + dx;
    ymax = ymin + dy;
    int ni=imFrame.nx*imFrame.ny;
    int ns=ps.nx*ps.ny;
  fprintf(stderr, "\timage (%d,%d) s=%.3lf [%.3lf,%.3lf] [%.3lf,%.3lf]\n",nx, ny, scale, xmin, xmax, ymin, ymax);

    zz = (double **) alloc_square_double(ny, nx);
   
    fp = fopen("final_image1.dat","w");
    for(i=0;i<imFrame.nx;i++)
    {
       for(j=0;j<imFrame.ny;j++)
       {  zz[j][i]=0.0;
          for(k=0;k<ns;k++)
          zz[j][i]+=fluxmap[i*ny+j][k]*sflux[k];
           fprintf(fp,"zz[%d][%d]=%e\n",j,i,zz[j][i]);
       }
    }
    fclose(fp);
  //  if (O.setseeing)
    //    d_seeing(zz, nx, ny, scale);

  //  if ( M.iref > 0 )
    wcsfull(imFrame.wcsinfo, &ra, &dec, &width, &height);
     wrf_fits_abs("testpixel_abs.fits", zz, nx, ny, xmin, xmax, ymin, ymax, ra, dec);
        
   // else
        wrf_fits("testpixel.fits", zz, nx, ny, xmin, xmax, ymin, ymax);
   
   // free_square_double(zz, ny);

}
